package meta_programming;

import java.lang.reflect.Field;

import meta_programming.Sample08.Foo;

public class Sample09 {
	public static void main(String[] args) throws Exception {
		String toString = ToStringBuilder.toString(new Foo());
		System.out.println(toString);
	}

	public static class ToStringBuilder {
		public static String toString(Object o) {
			StringBuilder ret = new StringBuilder();

			ret.append(o.getClass().getName());
			ret.append("[");

			Field[] declaredFields = o.getClass()
					.getDeclaredFields();

			for (Field field : declaredFields) {
				field.setAccessible(true);
				try {
					ret.append(field.getName() + " = "
							+ field.get(o));
					ret.append(", ");
				} catch (IllegalArgumentException ignore) {
				} catch (IllegalAccessException ignore) {
				}
			}

			if (0 < declaredFields.length) {
				ret.setLength(ret.length() - 2);
			}
			ret.append("]");

			return ret.toString();
		}
	}
}
